//+------------------------------------------------------------------+
//|                                                       TranMA.mq4 |
//|                                                         Mr. Gold |
//|                                         anna.furmanova@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Mr. Gold"
#property link      "anna.furmanova@yandex.ru"
#property version   "1.00"
#property strict

#define magic 888

extern double Lot             = 0.01;
extern int Magic              = 888;

extern string TriangularMa1   = "=====  TriangularMa1 =====";
extern string TimeFrame       = "current time frame";
extern int    Length          = 46;
extern int    TPrice          = 0;
extern int    EnvelopeShift   = 0;
extern double Deviation       = 0.15;

extern string TriangularMa2   = "=====  TriangularMa2 =====";
extern string TimeFrames      = "current time frame";
extern int    HalfLength      = 12;
extern int    Price           = 6;
extern double BandsDeviations = 3.0;

static int prevtime=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int b=0,s=0;
   for(int f=OrdersTotal()-1; f>=0; f--)
      if(OrderSelect(f,SELECT_BY_POS)==true)
         if(OrderSymbol()==Symbol())
           {
            if(OrderType()==0)b++;
            if(OrderType()==1)s++;
           }

   double TMA_0=iCustom(Symbol(),0,"TriangularMa centered envelope_mtf+alerts 2 nmc",TimeFrame,Length,TPrice,EnvelopeShift,Deviation,1,1);
   double TMA_1=iCustom(Symbol(),0,"TriangularMa centered envelope_mtf+alerts 2 nmc",TimeFrame,Length,TPrice,EnvelopeShift,Deviation,2,1);

   double MA_0=iCustom(Symbol(),0,"TriangularMA centered abands alerts 2",TimeFrames,HalfLength,Price,BandsDeviations,1,1);
   double MA_1=iCustom(Symbol(),0,"TriangularMA centered abands alerts 2",TimeFrames,HalfLength,Price,BandsDeviations,2,1);
   double MA_2=iCustom(Symbol(),0,"TriangularMA centered abands alerts 2",TimeFrames,HalfLength,Price,BandsDeviations,3,1);
   double MA_3=iCustom(Symbol(),0,"TriangularMA centered abands alerts 2",TimeFrames,HalfLength,Price,BandsDeviations,4,1);
   double MA_4=iCustom(Symbol(),0,"TriangularMA centered abands alerts 2",TimeFrames,HalfLength,Price,BandsDeviations,5,1);

   int tiket,cnt,total=OrdersTotal();

   if(Time[0]==prevtime)
      return(0);
   prevtime=Time[0];

   if(OrdersTotal()<1)
     {
      if(TMA_1>MA_2)
        {
         tiket=OrderSend(Symbol(),OP_BUY,Lot,Ask,3,0,0,"",Magic,0,clrGreen);
         if(tiket>0)
           {
            if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else
           {
            Print("Error opening BUY order : ",GetLastError());
            return(0);
           }
        }
      else if(TMA_0<MA_1)
        {
         tiket=OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0,"",Magic,0,clrRed);
         if(tiket>0)
           {
            if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else
           {
            Print("Error opening SELL order : ",GetLastError());
            return(0);
           }
        }
     }
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
           {
            if(TMA_1>MA_2)
              {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
               return(0);
              }
           }
         else
           {
            if(TMA_0<MA_1)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
               return(0);
              }
           }
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
